#ifndef CONFIG_H
#define CONFIG_H
#include <stdint.h>
#include <stdbool.h>
#include "stm32f107.h"

#define __ON                            (true)
#define __OFF                           (false)
#define __weak                          __attribute__((weak))

#define __PLL_CONFIG                    __ON
#define __RAM_VECT                      __OFF

// Процедуры
#define TIMRELOAD_CALC(time_us, freq_hz) \
(((time_us) * ((freq_hz) / 1000000)) - 1)

// Стек
#define STACK_SIZE                      (4096)

// Частота
#define HSE_OSC                         (25000000UL)

// Куча
extern uint8_t __end;
#define HEAP_BASE_ADDR                  &__end
#define HEAP_END_ADDR                   SRAM_END_ADDR

#endif // CONFIG_H

