#ifndef ULCD_DEFS_H
#define ULCD_DEFS_H

// Операции с регистрами
#define ULCD_CMD_REG_READ               (0x01)
#define ULCD_CMD_REG_WRITE              (0x02)
#define ULCD_CMD_REG_MOVE               (0x03)
#define ULCD_CMD_REG_INC                (0x04)
#define ULCD_CMD_REG_DEC                (0x05)
#define ULCD_CMD_REG_OR                 (0x06)
#define ULCD_CMD_REG_AND                (0x07)

// Операции с контейнерами
#define ULCD_CMD_BUFFER_CREATE          (0x08)
#define ULCD_CMD_BUFFER_DELETE          (0x09)
#define ULCD_CMD_BUFFER_SETSIZE         (0x0A)
#define ULCD_CMD_BUFFER_GETSIZE         (0x0B)
#define ULCD_CMD_BUFFER_WRITE           (0x0C)
#define ULCD_CMD_BUFFER_READ            (0x0D)
#define ULCD_CMD_BUFFER_LOAD            (0x0E)
#define ULCD_CMD_BUFFER_RUN             (0x0F)
#define ULCD_CMD_BUFFER_GETBYTE         (0x10)
#define ULCD_CMD_BUFFER_PUTBYTE         (0x11)
#define ULCD_CMD_BUFFER_GETSHORT        (0x12)
#define ULCD_CMD_BUFFER_PUTSHORT        (0x13)
#define ULCD_CMD_BUFFER_GETLONG         (0x14)
#define ULCD_CMD_BUFFER_PUTLONG         (0x15)

// Операции со шрифтами
#define ULCD_CMD_FONT_CREATE            (0x18)
#define ULCD_CMD_FONT_DELETE            (0x19)

// Операции с виджетами
#define ULCD_CMD_WIDGET_CREATE          (0x20)
#define ULCD_CMD_WIDGET_DELETE          (0x21)
#define ULCD_CMD_SETFRAME               (0x22)
// #define ULCD_CMD_WIDGET_SETFRAME        (0x22)
#define ULCD_CMD_WIDGET_REFRESH         (0x23)
#define ULCD_CMD_WIDGET_SETHANDLER      (0x24)
#define ULCD_CMD_WIDGET_GETHANDLER      (0x25)
#define ULCD_CMD_WIDGET_SETCOORD        (0x26)
#define ULCD_CMD_WIDGET_GETCOORD        (0x27)
#define ULCD_CMD_WIDGET_SETSIZE         (0x28)
#define ULCD_CMD_WIDGET_GETSIZE         (0x29)
#define ULCD_CMD_WIDGET_SETSTYLE        (0x2A)
#define ULCD_CMD_WIDGET_GETSTYLE        (0x2B)
#define ULCD_CMD_WIDGET_SETBGCOLOUR     (0x2C)
#define ULCD_CMD_WIDGET_GETBGCOLOUR     (0x2D)
#define ULCD_CMD_WIDGET_RESETBGCOLOUR   (0x2E)
#define ULCD_CMD_WIDGET_SETTEXTCOLOUR   (0x2F)
#define ULCD_CMD_WIDGET_GETTEXTCOLOUR   (0x30)
#define ULCD_CMD_WIDGET_RESETTEXTCOLOUR (0x31)
#define ULCD_CMD_WIDGET_SETFONT         (0x32)
#define ULCD_CMD_WIDGET_GETFONT         (0x33)
#define ULCD_CMD_WIDGET_SETDATA         (0x34)
#define ULCD_CMD_WIDGET_GETDATA         (0x35)
#define ULCD_CMD_WIDGET_SETPOSITION     (0x36)
#define ULCD_CMD_WIDGET_GETPOSITION     (0x37)

// Команды рисования
#define ULCD_CMD_DRAW_POINT             (0x80)
#define ULCD_CMD_DRAW_LINE              (0x81)
#define ULCD_CMD_DRAW_RECTANGLE         (0x82)
#define ULCD_CMD_FILL                   (0x8C)
#define ULCD_CMD_DRAW_BITMAP            (0x8D)
#define ULCD_CMD_DRAW_TEXT              (0x8F)
#define ULCD_CMD_DRAW_ELLIPSE           (0x92)

// Прочие команды
#define ULCD_CMD_NOP                    (0x00)
#define ULCD_CMD_SOFTRESET              (0xFE)
#define ULCD_CMD_TSCALIBRATION          (0xFF)

// Регистры общего назначения
#define ULCD_REG_R0                     (0x00)
#define ULCD_REG_R1                     (0x01)
#define ULCD_REG_R2                     (0x02)
#define ULCD_REG_R3                     (0x03)
#define ULCD_REG_R4                     (0x04)
#define ULCD_REG_R5                     (0x05)
#define ULCD_REG_R6                     (0x06)
#define ULCD_REG_R7                     (0x07)
#define ULCD_REG_R8                     (0x08)
#define ULCD_REG_R9                     (0x09)
#define ULCD_REG_R10                    (0x0A)
#define ULCD_REG_R11                    (0x0B)
#define ULCD_REG_R12                    (0x0C)
#define ULCD_REG_R13                    (0x0D)
#define ULCD_REG_R14                    (0x0E)
#define ULCD_REG_R15                    (0x0F)
#define ULCD_REG_R16                    (0x10)
#define ULCD_REG_R17                    (0x11)
#define ULCD_REG_R18                    (0x12)
#define ULCD_REG_R19                    (0x13)
#define ULCD_REG_R20                    (0x14)
#define ULCD_REG_R21                    (0x15)
#define ULCD_REG_R22                    (0x16)
#define ULCD_REG_R23                    (0x17)
#define ULCD_REG_R24                    (0x18)
#define ULCD_REG_R25                    (0x19)
#define ULCD_REG_R26                    (0x1A)
#define ULCD_REG_R27                    (0x1B)
#define ULCD_REG_R28                    (0x1C)
#define ULCD_REG_R29                    (0x1D)
#define ULCD_REG_R30                    (0x1E)
#define ULCD_REG_R31                    (0x1F)

// Общие регистры управления модулем
#define ULCD_REG_STATUS                 (0x21)
#define ULCD_REG_STATUS_BUSY            (0)
#define ULCD_REG_STATUS_SCR             (1)
#define ULCD_REG_STATUS_CMDERR          (2)
#define ULCD_REG_STATUS_SCRERR          (3)
#define ULCD_REG_SYSFONT                (0x24)
#define ULCD_REG_LCDCONFIG              (0x28)
#define ULCD_REG_LCDCONFIG_HILIGHT      (0)
#define ULCD_REG_LCDWIDTH               (0x2A)
#define ULCD_REG_LCDHEIGHT              (0x2B)
#define ULCD_REG_INTERRUPT              (0x30)

// Регистры операций с виджетами
#define ULCD_REG_PARENT                 (0x40)
#define ULCD_REG_CURRENT                (0x41)
#define ULCD_REG_POINTER                (0x42)
#define ULCD_REG_OPERAND0               (0x48)
#define ULCD_REG_OPERAND1               (0x49)
#define ULCD_REG_OPERAND2               (0x4A)
#define ULCD_REG_OPERAND3               (0x4B)
#define ULCD_REG_OPERAND4               (0x4C)
#define ULCD_REG_OPERAND5               (0x4D)
#define ULCD_REG_OPERAND6               (0x4E)
#define ULCD_REG_OPERAND7               (0x4F)
#define ULCD_REG_RESULT0                (0x50)
#define ULCD_REG_RESULT1                (0x51)
#define ULCD_REG_ERROR                  (0x58)

// Регистры операций с виджетами из скриптов
#define ULCD_REG_SCRPARENT              (0x80)
#define ULCD_REG_SCRCURRENT             (0x81)
#define ULCD_REG_SCRPOINTER             (0x82)
#define ULCD_REG_SCROPERAND0            (0x88)
#define ULCD_REG_SCROPERAND1            (0x89)
#define ULCD_REG_SCROPERAND2            (0x8A)
#define ULCD_REG_SCROPERAND3            (0x8B)
#define ULCD_REG_SCROPERAND4            (0x8C)
#define ULCD_REG_SCROPERAND5            (0x8D)
#define ULCD_REG_SCROPERAND6            (0x8E)
#define ULCD_REG_SCROPERAND7            (0x8F)
#define ULCD_REG_SCRRESULT0             (0x90)
#define ULCD_REG_SCRRESULT1             (0x91)
#define ULCD_REG_SCRERROR               (0x98)

// Регистры для рисования
#define ULCD_REG_PEN                    (0xC1)
#define ULCD_REG_BRUSH                  (0xC3)
#define ULCD_REG_FONT                   (0xC4)
#define ULCD_REG_ALPHA                  (0xC5)
#define ULCD_REG_ALPHA_COLOUR           (0)
#define ULCD_REG_ALPHA_ENABLE           (24)

// Операнды для загрузки данных
#define ULCD_LOAD_FROM_FLASH            (0x00)
#define ULCD_LOAD_FROM_SD               (0x01)

// Типы виджетов
#define ULCD_WIDGET_WINDOW              (0x00)
#define ULCD_WIDGET_FRAME               (0x01)
#define ULCD_WIDGET_BITMAP              (0x05)
#define ULCD_WIDGET_PANEL               (0x06)
#define ULCD_WIDGET_TEXT                (0x07)
#define ULCD_WIDGET_BUTTON              (0x0A)
#define ULCD_WIDGET_ROTATECONTROL       (0x0B)
#define ULCD_WIDGET_SLIDER              (0x0C)
#define ULCD_WIDGET_STATICLINE          (0x10)

// События
#define ULCD_EVT_DOWN                   (0x00)
#define ULCD_EVT_UP                     (0x01)
#define ULCD_EVT_DCLICK                 (0x02)
#define ULCD_EVT_HOLDDOWN               (0x03)
#define ULCD_EVT_ENTERWIN               (0x05)
#define ULCD_EVT_LEAVEWIN               (0x06)
#define ULCD_EVT_BUTTON                 (0x07)
#define ULCD_EVT_DRAW                   (0x08)
#define ULCD_EVT_ROTATE                 (0x09)
#define ULCD_EVT_SLIDER                 (0x0A)

// Стили
#define ULCD_STYLE_RAISED_BORDER        (1 << 2)
#define ULCD_STYLE_SUNKEN_BORDER        (1 << 3)
#define ULCD_STYLE_HORIZONTAL           (1 << 10)
#define ULCD_STYLE_VERTICAL             (1 << 11)
#define ULCD_STYLE_READONLY             (1 << 15)

// Ошибки
#define ULCD_ERROR_PERMISSIONS          (1)
#define ULCD_ERROR_MEMORY               (2)
#define ULCD_ERROR_TYPE                 (5)
#define ULCD_ERROR_BOUNDARY             (6)
#define ULCD_ERROR_IO                   (7)
#define ULCD_ERROR_PARENT               (8)
#define ULCD_ERROR_UNDEFTYPE            (9)

// Цвета
#define COLOUR_BLACK                    (0x00000000)
#define COLOUR_WHITE                    (0x00FFFFFF)
#define COLOUR_RED                      (0x00FF0000)
#define COLOUR_GREEN                    (0x0000FF00)
#define COLOUR_BLUE                     (0x000000FF)
#define COLOUR_YELLOW                   (0x00FFFF00)
#define COLOUR_CYAN                     (0x0000FFFF)
#define COLOUR_MAGENTA                  (0x00FF00FF)

#endif // ULCD_DEFS_H

